import { modifier } from 'ember-modifier';

interface Args {
  animation?: boolean;
  delay?: number | Record<string, unknown>;
  html?: boolean;
  placement?: 'auto' | 'top' | 'bottom' | 'left' | 'right';
  selector?: string | boolean;
  template?: string;
  trigger?: string;
  fallbackPlacements?: string[];
  boundary?: string | Element;
  customClass?: string | (() => void);
  sanitize?: boolean;
  allowList?: Record<string, unknown>;
  sanitizeFn?: null | (() => void);
  offset?: number[] | string | (() => void);
  popperConfig?: null | Record<string, unknown> | (() => void);
}

export default modifier(function tooltip(
  element: Element,
  [title]: unknown[],
  args: Args
): () => void {
  const tooltip = new (window as any).bootstrap.Tooltip(element, {
    title,
    ...args,
  });

  return () => {
    tooltip.dispose();
  };
});
